/**
 *
 * $Id: VkMsgClient.h,v 1.2 1995/04/20 05:32:07 toshok Exp $
 *
 * This file contains the class declaration for
 * VkMsgClient, which encapsulates the programmer's
 * interface to handling ToolTalk messages.
 *
 * Chris Toshok
 * Copyright (C) 1995
 * The Hungry Programmers, Inc.
 * All Rights Reserved
 *
 **/

#ifndef VKMSGCLIENT_H
#define VKMSGCLIENT_H

#include <Vk/VkConfig.h>
#include <Vk/VkMsgFacility.h>
#include <Vk/VkMsgMessage.h>

typedef Boolean (*VkMsgClientAction)(void*               /* clientDate */,
                                     VkMsgFacilityReason /* reason */,
                                     VkMsgMessage        /* msg_in */,
                                     char*               /* op */,
                                     int                 /* argc */,
                                     VkMsgArg*           /* argv */
                                     );

                    
class VkMsgClient {
public:

  sendStringNotice(char *op ...);
  sendIntNotice(char *op ...);

  void composeBegin();
  void composeAdd(char *val, VkMsgMode mode = VK_MSG_IN);
  void composeAdd(int ival, VkMsgMode mode = VK_MSG_IN);
  void composeAdd(unsigned char *val, int len,
                  VkMsgMode mode VK_MSG_IN); 

  void sendNotice(char *op);
  VkMsgMessage sendRequest(char *op);
  VkMsgMessage sendSyncRequest(char *op);

  void sendStringFileNotice(char *op, char *file ...);
  void sendIntFileNotice(char *op, char *file ...);
  void sendFileNotice(char *op, char *file);
  void sendFileRequest(char *op, char *file);
  void sendSyncFileRequest(char *op, char *file);
};

#endif // VKMSGCLIENT_H
