/**
 *
 * $Id: VkPrefGroup.h,v 1.2 1995/04/20 05:32:07 toshok Exp $
 *
 * This file contains the class definition for
 * the preference dialog group thingy, which
 * allows the programmer to group preference
 * items together.
 *
 * Chris Toshok
 * Copyright (C) 1995
 * Hungry Programmers, Inc
 * All Rights Reserved
 *
 **/

#ifndef VKPREFGROUP_H
#define VKPREFGROUP_H

#include <Vk/VkConfig.h>
#include <Vk/VkPrefItem.h>

class VkPrefGroup : public VkPrefItem {

public:
    VkPrefGroup(const char *name,
		Boolean horizOrientation = FALSE,
		Boolean noLabel = FALSE);
    
    void addItem(VkPrefItem *item);
    VkPrefItem *item(int item);
    int size();
    virtual void deleteChildren();

    Boolean changed();
    VkPrefItemType type();
    Boolean isContainer();
    const char *className();
};

#endif // VkPREFGROUP_H
