/**
 *
 * $Id: VkPrefItem.h,v 1.4 1995/04/20 05:32:07 toshok Exp $
 *
 * This file contains the class definition for
 * VkPrefItem, which forms the base class for
 * all items which are allowable inside of preference
 * dialogs.
 *
 * Chris Toshok
 * Copyright (C) 1995
 * The Hungry Programmers, Inc
 * All Rights Reserved
 *
 **/

#ifndef VKPREFITEM_H
#define VKPREFITEM_H

#include <Vk/VkConfig.h>
#include <Vk/VkComponent.h>

class VkPrefItem : public VkComponent {
protected:
    Widget _labelWidget;
    Boolean instantiated;
public:
    enum VkPrefItemType {PI_group, PI_LIST, PI_radio, PI_text, PI_toggle,
			 PI_option, PI_empty, PI_label, PI_separator,
			 PI_custom, PI_none};
    VkPrefItem(const char *name);


    virtual Boolean changed()=0;

    void activate();
    void deactivate();

    void setLabelHeight(Dimension h);
    void setBaseHeight(Dimension h);

    Widget labelWidget() {return _labelWidget;};

    virtual VkPrefItemType type()=0;

    virtual Boolean isContainer()=0;

    virtual const char *className()=0;

    virtual void _instantiate(Widget parent) = 0;
};

#endif // VKPREFITEM_H
