/**
 *
 * $Id: VkProgram.h,v 1.2 1995/04/20 05:32:07 toshok Exp $
 *
 * Chris Toshok
 * Copyright (C) 1995
 * The Hungry Programmer, Inc.
 * All Rights Reserved
 *
 **/

#ifndef VKPROGRAM_H
#define VKPROGRAM_H

#include <Vk/VkConfig.h>
#include <Vk/VkCallbackObject.h>
#include <Vk/VkSubProcess.h>

class VkProgram : public VkCallbackObject {
protected:
    char *_cmd;
    int _killChildOnExit;
    int _redirectIn;

public:
    VkProgram(const char *cmd, int killChildOnExit = 1);
    
    virtual ~VkProgram(void);

    virtual VkSubProcess *run(void);

    void redirectIn(int do_redirect);

    static const char *const exitCallback;
    static const char *const stdoutCallback;
    static const char *const stderrCallback;
};

#endif // VKPROGRAM_H
