/**
 *
 * $Id: VkRunOnce.h,v 1.2 1995/04/20 05:32:07 toshok Exp $
 *
 * This file contains the definition for the VkRunOnce class,
 * which allows applications to specify that they should only
 * be run once on a given machine. 
 *
 * Chris Toshok
 * Copyright (C) 1995
 * The Hungry Programmers, Inc.
 * All RIghts Reserved
 *
 **/

#ifndef VKRUNONCE_H
#define VKRUNONCE_H

#include <Vk/VkConfig.h>
#include <Vk/VkCallbackObject.h>
#include <Vk/VkNameList.h>

class VkRunOnce : public VkCallbackObject {
public:
    VkRunOnce(VkNameList *args, Boolean per_host);
    ~VkRunOnce();

    int numArgs();
    char *arg(int index);

    const char *const invokedCallback;
};

#endif // VKRUNONCE_H
