/**
 *
 * VkBackground.C
 *
 * This file contains the implementation for VkBackground,
 * which gives the programmer an interface to Xt work
 * procs.
 *
 * Chris Toshok
 * Copyright (C) 1995
 * The Hungry Programmers, Inc
 * All Rights Reserved
 *
 **/

#include <Vk/VkBackground.h>
#include <Vk/VkApp.h>

VkBackground::VkBackground()
{
    _id = 0;
}

VkBackground::~VkBackground()
{
    stop();
}

void
VkBackground::start()
{
    _id = XtAppAddWorkProc(theApplication->appContext(),
			   (XtWorkProc)timeSliceHandler,
			   (XtPointer)this);
}

void
VkBackground::stop()
{
    if (_id != -1)
	XtRemoveWorkProc(_id);
}

Boolean 
VkBackground::timeSliceHandler(XtPointer clientData)
{
    VkBackground *obj = (VkBackground *)clientData;
    
    return obj->timeSlice();
}


