/**
 *
 * VkCombo.C
 *
 * This file contains the implementation of the VkCombo class,
 * which gives the look of the microsoft list selection thingys.
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#include <Vk/VkCombo.h>

#ifndef lint
static char rcsid[] = "$Id: VkCombo.C,v 1.2 1995/03/28 22:22:28 toshok Exp $";
#endif

VkCombo::VkCombo(Widget parent, const char *name) : VkComponent(name)
{
    _baseWidget = XtCreateManagedWidget(name,
		  		        xmComboBoxWidgetClass,
					parent,
					NULL, 0);

    XtAddCallback(_baseWidget, XmNselectionCallback, _selectionCallback, this);
}

int
VkCombo::getIndex()
{
  return 0;
}

char *
VkCombo::getValue()
{
    return XmComboBoxGetString(_baseWidget);
}

void
VkCombo::setIndex(int index)
{
    XmComboBoxSelectPos(_baseWidget, index, False);
}

void
VkCombo::setValue(char *value)
{
    XmString xmstr;

    xmstr = XmStringCreateSimple(value);

    XmComboBoxSelectItem(_baseWidget, xmstr, False);

    XmStringFree(xmstr);
}

void
VkCombo::selectIndex(int index)
{
    XmComboBoxSelectPos(_baseWidget, index, True);
}

void
VkCombo::selectValue(char *value)
{
    XmString xmstr;

    xmstr = XmStringCreateSimple(value);

    XmComboBoxSelectItem(_baseWidget, xmstr, True);

    XmStringFree(xmstr);
}

void
VkCombo::addItem(char *newItem)
{
    XmString xmstr = XmStringCreateSimple(newItem);

    XmComboBoxAddItem(_baseWidget, xmstr, 0);

    XmStringFree(xmstr);
}

const char *
VkCombo::className()
{
    return "VkCombo";
}

void
VkCombo::_selectionCallback(Widget w, XtPointer clientData, XtPointer callData)
{
    VkCombo *obj = (VkCombo*)clientData;

    obj->callCallbacks(VkCombo::ItemSelectedCallback, (void*)callData);
}

const char * const VkCombo::ItemSelectedCallback = "VkCombo::ItemSelected";
