/**
 *
 * VkComponentList.h
 *
 * This file contains the implementation for my workaround
 * for the missing VkComponentList class.  I can find no
 * hardcopy documentation for this class, so until I have access
 * to the man pages, I can only use this :(
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#ifndef lint
static char rcsid[] = "$Id: VkComponentList.C,v 1.5 1995/01/23 10:07:18 toshok Exp $";
#endif /* lint */

#include <Vk/VkComponentList.h>
#include <iostream.h>
#include <stdlib.h>
#include <assert.h>

VkComponentList::VkComponentList()
{
    max_number_of_elements = 10;
    elements = (VkComponent**)malloc(10 * sizeof(VkComponent*));
    number_of_elements = 0;
}

void
VkComponentList::add(VkComponent *c)
{
    assert(number_of_elements < max_number_of_elements);

    elements[number_of_elements++] = c;
  
    if (number_of_elements == max_number_of_elements){
	max_number_of_elements *= 2;

	elements = (VkComponent**)malloc(max_number_of_elements * sizeof(VkComponent*));
    }
}

void
VkComponentList::remove(VkComponent *c)
{
    assert(c != NULL);

    int i,j;
  
    for (i=0; i< number_of_elements; i++)
	if (elements[i] == c) // we found it
	{
	    for (j=i; j<number_of_elements-1; j++)
		elements[j] = elements[j+1];

	    number_of_elements --;

	    return;
	}
    cerr << "Unable to find element in VkComponentList " << endl;
}
