/**
 *
 * VkCursorList.C
 *
 * This file contains the implementation of the class VkCursorList.  This
 * class makes it easier to add an animated cursor to your applications.
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#include <Vk/VkCursorList.h>

#ifndef lint
static char rcsid[] = "$Id: VkCursorList.C,v 1.1 1994/11/29 16:41:05 toshok Exp $";
#endif /* lint */

VkCursorList::VkCursorList(int numCursors)
{
  int i;
  
  _numCursors = numCursors;
  _cursorList = new Pixmap[_numCursors];

  for (i=0; i< _numCursors; i++)
    _cursorList[i] = None;
}

Cursor 
VkCursorList::operator[] (int index) const
{
  return _cursorList[index];
}

void
VkCursorList::progress()
{
  _currentIndex = (_currentIndex +1) % _numCursors;
}

int
VkCursorList::index()
{
  return _currentIndex;
}
