/**
 *
 * VkFormat.C
 *
 * This file contains the implementation for
 * The VkFormat function, which is mainly just
 * a souped up sprintf which gives you the ability
 * to use viewkit things in the format string.
 *
 * Also, my first function _ever_ to use stdargs.  neat.
 *
 * Chris Toshok
 * Copyright (C) 1994, 1995
 * The Hungry Programmers, Inc.
 *
 **/

#include <Vk/VkFormat.h>
#include <Vk/VkApp.h>
#include <stdarg.h>
#include <stdlib.h>

extern "C" {

const char *
VkFormat (const char *fmt, ...)
{
    va_list ap;
    static char *ret_value;

    if (!ret_value)
	ret_value = (char*)malloc(1000 * sizeof(char));
    
    ret_value[0] = 0;

    const char *less_than;
    const char *old_less_than;
    char temp[1000];

    temp[0] = 0;

    va_start(ap, fmt);

    old_less_than = &(fmt[0]);
    less_than = &(fmt[0]);
	
    while (less_than = strchr(old_less_than, (int)'<'))
    {
	strncat(temp, old_less_than, (less_than - old_less_than));

	if (!strncmp(less_than, "<application>", strlen("<application>"))){
	    strcat(temp, theApplication->applicationClassName());

	    old_less_than = less_than + strlen("<application>");
	}
	else{
	    strcat(temp, "<");

	    old_less_than = less_than + 1;
	}
    }

    strcat(temp, old_less_than);

    vsprintf(ret_value, temp, ap);

    va_end(ap);

    return ret_value;
}

};

