/**
 *
 * VkGenericDialog.C
 *
 * This file contains the class implementation
 * for VkGenericDialog boxes, which form
 * the base, abstract class from which programmers
 * can extend, providing necessary dialog
 * functionality.
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#ifndef lint
static char rcsid[] = "$Id: VkGenericDialog.C,v 1.6 1995/04/02 03:03:12 toshok Exp $";
#endif /* lint */

#include <Vk/VkGenericDialog.h>

VkGenericDialog::VkGenericDialog(const char *name) : VkDialogManager(name)
{
    _dialogShellTitle = NULL;
    _okButton = True;
    _helpButton = True;
    _cancelButton = True;
}

Widget
VkGenericDialog::createDialog(Widget parent)
{
    XmString okLabel = XmStringCreateSimple("Ok");
    XmString cancelLabel = XmStringCreateSimple("Cancel");
    XmString applyLabel = XmStringCreateSimple("Apply");
    XmString helpLabel = XmStringCreateSimple("Help");

    Arg args[4]; 
    int n = 0;

    XtSetArg(args[n],XmNokLabelString, okLabel); n++;
    XtSetArg(args[n],XmNcancelLabelString, cancelLabel); n++;
    XtSetArg(args[n],XmNapplyLabelString, applyLabel); n++;
    XtSetArg(args[n],XmNhelpLabelString, helpLabel); n++;

    Widget dialogBox = XmCreateTemplateDialog(parent,
					      (char *)_name,
					      args,n);
    
    return dialogBox;
}

const char *
VkGenericDialog::className()
{
    return "VkGenericDialog";
}
