/**
 *
 * VkMenuAction.C
 *
 *
 * This file contains the source for the VkMenuAction class.
 * This class, and its derivatives, account for most of the user
 * interface acreage that you normally see.  It's a pretty important
 * class.
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#ifndef lint
static char rcsid[] = "$Id: VkMenuAction.C,v 1.2 1995/01/23 10:07:34 toshok Exp $";
#endif /* lint */

#include <Vk/VkMenuAction.h>
#include <iostream.h>

VkMenuAction::VkMenuAction(char *name) : VkMenuItem(name)
{
}

const char *
VkMenuAction::className()
{
  return "VkMenuAction";
}

Boolean
VkMenuAction::hasUndo()
{
  return False; // For Now
}

void
VkMenuAction::undo()
{
}

VkMenuItemType
VkMenuAction::menuType()
{
  return ACTION;
}

void
VkMenuAction::_instantiate(Widget parent)
{
  _baseWidget = XmCreatePushButtonGadget(parent,
					 (char*)name(),
					 NULL,0);

  if (actionCallback)
    XtAddCallback(_baseWidget, XmNactivateCallback, actionCallback, clientData);
  
  XtManageChild(_baseWidget);

  if (activated == False)
    XtSetSensitive(_baseWidget, False);

  instantiated = TRUE;
}

void
VkMenuAction::setLabel(const char *str)
{
  Arg args[1];
  XmString xmstr;

  xmstr = XmStringCreateSimple ((char *)str);
  
  XtSetArg(args[0], XmNlabelString, xmstr);

  XtSetValues(_baseWidget, args, 1);

  XmStringFree(xmstr);
}

Boolean
VkMenuAction::isContainer()
{
  return FALSE;
}











