/**
 *
 * VkMenuConfirmFirstAction.C
 *
 * This file contains the source code for the implementation of the
 * VkMenuConfirmFirstAction controls.
 *
 * Chris Toshok
 * Copyright (C) 1995
 * The Hungry Programmers, Inc
 *
 **/

#ifndef lint
static char rcsid[] = "$Id: VkMenuConfirmFirstAction.C,v 1.5 1995/04/10 01:48:32 toshok Exp $";
#endif /* lint */

#include <Vk/VkMenuConfirmFirstAction.h>
#include <Vk/VkQuestionDialog.h>
#include <Vk/VkApp.h>

#include <stdlib.h>

VkMenuConfirmFirstAction::VkMenuConfirmFirstAction(char *name) : VkMenuAction(name)
{
}

VkMenuItemType
VkMenuConfirmFirstAction::menuType()
{
    return CONFIRMFIRSTACTION;
}

void
VkMenuConfirmFirstAction::_confirmCallback(Widget, XtPointer clientData, XtPointer)
{
    VkMenuConfirmFirstAction *obj = (VkMenuConfirmFirstAction*)clientData;
  
    char *msg = (char*)calloc(100, sizeof(char));

    sprintf (msg, "*%s.%s", obj->name(), "noUndoQuestion");

    if (VkGetResource(obj->baseWidget(),
		      msg,
		      "NoUndoQuestion",
		      XmRString,
		      NULL)) /* resource was set */
	theQuestionDialog->post(msg, obj->actionCallback, NULL, NULL, obj->clientData, NULL, theApplication->mainWindow(), NULL);
    else

	theQuestionDialog->post("This action cannot be undone.  Do you want to proceed anyway?", 
				obj->actionCallback, NULL, NULL, obj->clientData, NULL, theApplication->mainWindow(), NULL);
}

void
VkMenuConfirmFirstAction::_instantiate(Widget parent)
{
    _baseWidget = XmCreatePushButtonGadget(parent,
					   (char *)name(),
					   NULL,0);

    if (actionCallback)
	XtAddCallback(_baseWidget, XmNactivateCallback, _confirmCallback, (XtPointer)this);

    XtManageChild(_baseWidget);

    if (activated == False)
	XtSetSensitive(_baseWidget, False);

    instantiated = TRUE;
}

const char *
VkMenuConfirmFirstAction::className()
{
    return "VkMenuConfirmFirstAction";
}

Boolean
VkMenuConfirmFirstAction::isContainer()
{
    return FALSE;
}
