/**
 *
 * VkMenuItem.C
 *
 *
 * This file contains the class implementation for the VkMenuItem class, which
 * forms the base for all the menu elements in the ViewKit Library.
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#ifndef lint
static char rcsid[] = "$Id: VkMenuItem.C,v 1.2 1995/01/23 10:07:38 toshok Exp $";
#endif /* lint */

#include <Vk/VkMenuItem.h>
#include <stdlib.h>
#include <iostream.h>

VkMenuItem::VkMenuItem(char *name) : VkComponent(name)
{
  instantiated = FALSE;
  activated = True;
}

VkMenuItem::~VkMenuItem()
{
  //empty
}

const char *
VkMenuItem::className()
{
  return "VkMenuItem";
}

void
VkMenuItem::show()
{
  XtManageChild(_baseWidget);
}

void
VkMenuItem::hide()
{
  XtUnmanageChild(_baseWidget);
}

void
VkMenuItem::remove()
{
  //  I have no idea how this should work, other than to unmanage the widget
}

void
VkMenuItem::activate()
{
  Arg arg[1];

  XtSetSensitive(_baseWidget, True);
  
  activated = True;
}

void
VkMenuItem::deactivate()
{
  Arg arg[1];

  XtSetSensitive(_baseWidget, False);

  activated = False;
}

void
VkMenuItem::setPosition(int /*position*/)
{
}

void
VkMenuItem::_instantiate(Widget)
{
}

VkMenuItem::operator Widget() const
{
  return _baseWidget;
}
