/**
 *
 * VkMenuLabel.C
 *
 * 
 * This file contains the source code for the implementation of the
 * (rather boring) VkMenuLabel class, which give the programmer
 * the ability to place (rather boring) labels within menus.
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#ifndef lint
static char rcsid[] = "$Id: VkMenuLabel.C,v 1.2 1995/01/23 10:07:39 toshok Exp $";
#endif /* lint */

#include <Vk/VkMenuLabel.h>

VkMenuLabel::VkMenuLabel(char *name) : VkMenuItem (name)
{
  // empty for now.
}

Boolean
VkMenuLabel::isContainer()
{
  return FALSE;
}

VkMenuItemType
VkMenuLabel::menuType()
{
  return LABEL;
}

void
VkMenuLabel::setLabel(const char *str)
{
  Arg args[1];
  XmString xmstr;

  xmstr = XmStringCreateSimple ((char *)str);
  
  XtSetArg(args[0], XmNlabelString, xmstr);

  XtSetValues(_baseWidget, args, 1);
  XmStringFree(xmstr);  
}

void
VkMenuLabel::_instantiate(Widget parent)
{
  _baseWidget = XmCreateLabelGadget(parent,
				    (char *)name(),
				    NULL,0);

  XtManageChild(_baseWidget);

  if (activated == False)
    XtSetSensitive(_baseWidget, False);

  instantiated = TRUE;
}

const char *
VkMenuLabel::className()
{
  return "VkMenuLabel";
}

