/**
 *
 * VkPeriodic.C
 *
 * This file contains the class implementation for the 
 * VkPeriodic class, which encapsulates the Xt timeout
 * implementation, and offers periodic timeouts.
 *
 * Chris Toshok
 * Copyright (C) 1994, 1995
 * The Hungry Programmers, Inc.
 *
 **/

#include <Vk/VkPeriodic.h>
#include <Vk/VkApp.h>

const char *const VkPeriodic::timerCallback = "VkPeriodicTimerCallback";

VkPeriodic::VkPeriodic(int interval)
{
    _interval = interval;
}

VkPeriodic::~VkPeriodic()
{
    stop();
}

void
VkPeriodic::start()
{
    _id = XtAppAddTimeOut(theApplication->appContext(),
			  _interval,
			  tickTimeOut,
			  this);
}

void
VkPeriodic::stop()
{
    XtRemoveTimeOut(_id);
}

void
VkPeriodic::tickTimeOut(XtPointer clientData,
			XtIntervalId *)
{
    VkPeriodic *obj = (VkPeriodic*)clientData;

    obj->tick();

    obj->callCallbacks(timerCallback, NULL);

    obj->_id = XtAppAddTimeOut(theApplication->appContext(),
			       obj->_interval,
			       obj->tickTimeOut,
			       obj);
}
