/**
 *
 * VkPrefDialog.C
 *
 * This file contains the implemtation for the 
 * VkPrefDialog class, which implements a preference
 * dialog box, subclassed from VkGenericDialog.
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#ifndef lint
static char rcsid[] = "$Id: VkPrefDialog.C,v 1.1 1994/11/30 21:21:31 toshok Exp $";
#endif /* lint */

#include <Vk/VkPrefDialog.h>

VkPrefDialog::VkPrefDialog(const char *name, VkPrefItem *item) : VkGenericDialog(name)
{
    _applyButton = True;
    _okButton = True;
    _cancelButton = True;

    _item = NULL;
}

void 
VkPrefDialog::setItem(VkPrefItem *item)
{
    if (_item)
	_item->deactivate();

    _item = item;

    _item->_instantiate(_dialogBox);
    _item->activate();
}

VkPrefItem *
VkPrefDialog::item()
{
    return _item;
}

Widget
VkPrefDialog::createDialog(Widget parent)
{
    _dialogBox = XmCreateSelectionBox(parent,
				      (char*)_name,
				      NULL,0);

    if (_item){
	_item->instantiate(_dialogBox);
	_item->activate();
    }
    else{
	cerr << "VkPrefDialog Created widhout item" << endl;
	exit(1);
    }
}

