/**
 *
 * VkPrefItem.C
 *
 * This file contains the implementation for
 * the base, abstract class VkPrefItem
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#ifndef lint
static char rcsid[] = "$Id: VkPrefItem.C,v 1.5 1995/01/23 10:07:44 toshok Exp $";
#endif /* lint */

#include <Vk/VkPrefItem.h>
#include <stdlib.h> // for malloc

VkPrefItem::VkPrefItem(const char *name) : VkComponent(name)
{
    instantiated = False;
    _labelWidget = NULL;
}

void
VkPrefItem::activate()
{
    Arg args[1];

    XtSetSensitive(_baseWidget, False);

    if (_labelWidget)
	XtSetValues(_labelWidget, args, 1);
}

void
VkPrefItem::deactivate()
{
    Arg args[1];

    XtSetArg(args[0], XmNsensitive, False);

    XtSetValues(_baseWidget, args, 1);
    if (_labelWidget)
	XtSetValues(_labelWidget, args, 1);
}

void
VkPrefItem::setLabelHeight(Dimension h)
{
    Arg args[1];

    if (_labelWidget){
	XtSetArg(args[0], XtNheight, h);
	
	XtSetValues(_labelWidget, args, 1);
    }
}

void
VkPrefItem::setBaseHeight(Dimension h)
{
    Arg args[1];

    XtSetArg(args[0], XtNheight, h);

    XtSetValues(_baseWidget, args, 1);
}

