/**
 *
 * VkRadioSubMenu.C
 *
 * This file contains the source code for the implementation
 * of the sub types.
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#ifndef lint
static char rcsid[] = "$Id: VkRadioSubMenu.C,v 1.2 1995/01/23 10:07:51 toshok Exp $";
#endif /* lint */

#include <Vk/VkRadioSubMenu.h>

VkRadioSubMenu::VkRadioSubMenu(const char *name,
			       VkMenuDesc *menuDesc,
			       XtPointer defaultClientData) : VkSubMenu(name)
{
}

VkMenuItemType
VkRadioSubMenu::menuType()
{
  return RADIOSUBMENU;
}

const char *
VkRadioSubMenu::className()
{
  return "VkRadioSubMenu";
}

void
VkRadioSubMenu::_instantiate(Widget parent)
{
  Arg args[2];
  int i;

  XtSetArg(args[0], XmNradioBehavior, True);

  if (_tearOff)
    XtSetArg(args[1], XmNtearOffModel, XmTEAR_OFF_ENABLED);
  else
    XtSetArg(args[1], XmNtearOffModel, XmTEAR_OFF_DISABLED);
    
  _pulldown = XmCreatePulldownMenu(parent,
				   (char *)name(),
				   args,2);
  
  _pulldown = XmCreatePulldownMenu(parent,
				   (char *)name(),
				   args,1);
  
  XtSetArg(args[0], XmNsubMenuId, _pulldown);
  
  _baseWidget = XmCreateCascadeButtonGadget(parent,
					    (char *)name(),
					    args,1);

  XtManageChild(baseWidget());
  
  for (i=0; i<numberOfElements; i++)
    elements[i]->_instantiate(_pulldown);

  if (activated == False)
    XtSetSensitive(_baseWidget, False);

  instantiated = TRUE;
}



