/**
 *
 * VkSelectionDialog.C
 *
 * This file contains the class implementation for the VkSelectionDialog
 * class.
 *
 * Chris Toshok
 * Copyright (C) 1994
 * The Hungry Programmers, Inc
 *
 **/

#ifndef lint
static char rcsid[] = "$Id: VkSelectionDialog.C,v 1.5 1995/02/15 17:42:14 toshok Exp $";
#endif /* lint */

#include <Vk/VkSelectionDialog.h>
#include <Vk/VkApp.h>
#include <string.h>
#include <stdlib.h>
#include <iostream.h>
#include <Xm/List.h>

VkSelectionDialog::VkSelectionDialog(const char *name) : VkDialogManager(name)
{
  _dialogShellTitle = NULL;
  _okButton = True;
  _helpButton = False;
  _cancelButton = True;

  _numberOfItems = 0;
  _maxNumberOfItems = 10;

  items = (XmString*)malloc(_maxNumberOfItems * sizeof(XmString));
}

VkSelectionDialog::~VkSelectionDialog()
{
  int i;

  for (i=0; i<_maxNumberOfItems; i++)
	XmStringFree(items[i]);

  free(items);
}

Widget
VkSelectionDialog::createDialog(Widget parent)
{
  Arg args[3];
  int n;

  n=0;
  if (_numberOfItems >0){
    XtSetArg(args[n], XmNlistItems, items); n++;
    XtSetArg(args[n], XmNlistItemCount, _numberOfItems); n++;
  }
  
  Widget dialogBox = XmCreateSelectionDialog(parent,
					     (char*)_name,
					     args, n);

  return dialogBox;
}

void
VkSelectionDialog::addItem(char *item)
{
  items[_numberOfItems++] = XmStringCreateSimple(item);

  if (_numberOfItems==_maxNumberOfItems){
      _maxNumberOfItems += 10;
      items = (XmString *)realloc(items, _maxNumberOfItems * sizeof(XmString));
  }

/*  if (_cachedDialog) 
    XtVaSetValues(_dialogBox,
                  XmNlistItems, items,
                  XmNlistItemCount, _numberOfItems,
                  NULL);*/
}

int
VkSelectionDialog::index(XmString item)
{
/*  if (_cachedDialog)
    return XmListItemPos(XmSelectionBoxGetChild(_dialogBox, XmDIALOG_LIST),
                         item);
  else
*/
    return -1;
}

const char *
VkSelectionDialog::className()
{
  return "VkSelectionDialog";
}

VkSelectionDialog *_theSelectionDialogManager = new VkSelectionDialog("SelectionDialogManager");
