/**
 *
 * $Header: /tmp_mnt/net/bayhorse1/student/toshok/hungry/programming/misc/c++/libvk-0.8/libvk-Apr19-2243/RCS/VkSubProcess.C,v 1.1 1995/04/10 01:48:32 toshok Exp $
 *
 * Copyright (C) 1995
 * The Hungry Programmers, Inc.
 * All Rights Reserved
 *
 **/

#include <Vk/VkSubProcess.h>
#include <sys/types.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h> // for exec*

VkSubProcess::VkSubProcess(char *prog,
			   VkNameList *given,
			   int killChildOnExit,
			   int redirectIn)
{
    _pid = 0;
    _redirectIn = redirectIn;
    _killMeOnExit = killChildOnExit;
    _cmd = strdup(prog);
    _args = new VkNameList(*given);

    _stdin = 
	_stderr = 
	_stdout = NULL;
}

VkSubProcess::~VkSubProcess()
{
    delete _stdout;
    delete _stderr;
    delete _stdin;

    free(_cmd);
}

pid_t
VkSubProcess::pid()
{
    return _pid;
}

int
VkSubProcess::exitStatus()
{
}

int 
VkSubProcess::stdinfd()
{
    return stdinFd;
}

VkPipe *
VkSubProcess::getStdoutPipe()
{
    return _stdout;
}

VkPipe *
VkSubProcess::getStderrPipe()
{
    return _stderr;
}

void
VkSubProcess::signal(int sig)
{
    kill(sig);
}

void
VkSubProcess::kill(int sig)
{

    printf ("calling ::kill()\n");
    ::kill(_pid, sig);
}

void
VkSubProcess::run()
{
    int stdoutOut;
    int stderrOut;

    if (_redirectIn)
	_stdin = new VkPipe(stdinFd);

    _stdout = new VkPipe(stdoutOut);
    _stderr = new VkPipe(stderrOut);

    if ((_pid = fork()) == 0)
    {
	/* child */

	dup2(stdoutOut, 1);
	dup2(stderrOut, 2);
	dup2((*_stdin)[READ], 0);

	execvp(_cmd, (char**)(*_args));
    }
    else
    {
	/* parent */
    }
}


