/**
 *
 * builtinbusy.C
 *
 * This file contains the implementation of the built-in busy cursor
 *
 * Chris Toshok
 *
 **/

#include <Vk/builtinbusy.h>

BuiltInBusyCursor::BuiltInBusyCursor() : VkCursorList (NUMCURSORS)
{
  xcolors[0].pixel = (Pixel) VkGetResource(theApplication->baseWidget(),
					  "busyCursorForeground",
					  XmCForeground,
					  XmRPixel,
					  (const char*)BlackPixelOfScreen(
                                           DefaultScreenOfDisplay(theApplication->display())));

  xcolors[1].pixel = (Pixel) VkGetResource(theApplication->baseWidget(),
					  "busyCursorBackground",
					  XmCBackground,
					  XmRPixel,
					  (const char*)WhitePixelOfScreen(
                                           DefaultScreenOfDisplay(theApplication->display())));

  XQueryColors (theApplication->display(),
		DefaultColormapOfScreen(DefaultScreenOfDisplay(theApplication->display())),
		xcolors, 2);
}

void BuiltInBusyCursor::createCursor(int index)
{
  Pixmap pixmap = 0, maskPixmap = 0;

  Display *dpy = theApplication->display();

  pixmap = XCreateBitmapFromData(dpy,
				 DefaultRootWindow(dpy),
				 clock_bits[index*2],
				 30,27);

  maskPixmap = XCreateBitmapFromData(dpy,
				 DefaultRootWindow(dpy),
				 clock_bits[index*2+1],
				 30,27);

  _cursorList[index] = XCreatePixmapCursor (dpy, pixmap, maskPixmap,
					    &(xcolors[0]), &(xcolors[1]),
					    0,0);

  if (pixmap)
    XFreePixmap(dpy, pixmap);
  if (maskPixmap)
    XFreePixmap(dpy, maskPixmap);
}

